#include <iostream>
#include <vector>
#include <cmath>
#include <fstream>
#include "algorithm"

using namespace std;

const double Pi = 3.141592653589793;
int main() {
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    int n;
    double r;
    cin >> n >> r;
    vector<pair<double, bool>> a;
    double fi, h;
    int start_ans = 0;
    for (int i = 0; i < n; ++i) {
        cin >> fi >> h;
        double alpha = acos(r / (r + h));
        double fi1 = fi - alpha, fi2 = fi + alpha;
        if (fi1 < 0) {
            start_ans += 1;
            fi1 += 2 * Pi;
        }
        if (fi2 > 2 * Pi) {
            start_ans += 1;
            fi2 -= 2 * Pi;
        }
        a.emplace_back(fi1, true);
        a.emplace_back(fi2, false);
    }
    std::sort(a.begin(), a.end());
    bool ans = start_ans == 0;
    for (auto i : a) {
        if (i.second) {
            ++start_ans;
        } else {
            --start_ans;
        }
        if (!start_ans) {
            ans = true;
        }
    }
    if (ans) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
