#include <iostream>
#include <vector>
#include <cmath>
#include <fstream>
#include "algorithm"

using namespace std;

const double Pi = 3.141592653589793;
int main() {
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    int n;
    double r;
    cin >> n >> r;
    vector<pair<double, double>> a;
    int start_ans = 0;
    for (int i = 0; i < n; ++i) {
        double fi, h;
        cin >> fi >> h;
        a.emplace_back(fi, h);
    }
    std::sort(a.begin(), a.end());
    bool ans = false;
    for (int i = 0; i < n; ++i) {
        bool tmp = true;
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            double alpha = a[j].first - a[i].first;
            if (alpha < 0) {
                alpha += 2 * Pi;
            }
            if (alpha < 0 || alpha > Pi) continue;
            double a1 = r + a[i].second;
            double a2 = r + a[j].second;
            double a3 = sqrt(a1 * a1 + a2 * a2 - 2 * a1 * a2 * cos(alpha));
            double S = a1 * a2 * sin(alpha) / 2;
            double h = 2 * S / a3;
            if (h >= r) {
                tmp = false;
                break;
            }
        }
        if (tmp) {
            ans = true;
            break;
        }
    }
    if (ans) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
